﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace DSO_CSharp
{
	class DSOSDK_Class
	{
		[DllImport("DSOSDK.dll", CallingConvention = CallingConvention.StdCall, EntryPoint = "uDsoSDKMeasExInit")]
		private static extern bool _uDsoSDKMeasExInit(int iCh, int iVoltDiv, double dbVOfs, double dbYOfsA, double dbYOfsB, double dbYMul, int iProbe, Int64 iScData, int iBufLen, [Out] short[] lpwWaveform);
		public bool uDsoSDKMeasExInit(int iCh, int iVoltDiv, double dbVOfs, double dbYOfsA, double dbYOfsB, double dbYMul, int iProbe, Int64 iScData, int iBufLen, [Out] short[] lpwWaveform)
		{
			return _uDsoSDKMeasExInit(iCh, iVoltDiv, dbVOfs, dbYOfsA, dbYOfsB, dbYMul, iProbe, iScData, iBufLen, lpwWaveform);
		}

		[DllImport("DSOSDK.dll", CallingConvention = CallingConvention.StdCall, EntryPoint = "uDsoSDKMeasExAddType")]
		private static extern bool _uDsoSDKMeasExAddType(int iType);
		public bool uDsoSDKMeasExAddType(int iType)
		{
			return _uDsoSDKMeasExAddType(iType);
		}

		[DllImport("DSOSDK.dll", CallingConvention = CallingConvention.StdCall, EntryPoint = "uDsoSDKMeasExStart")]
		private static extern bool _uDsoSDKMeasExStart(int iStart, int iEnd, ref bool pbForceStop);
		public bool uDsoSDKMeasExStart(int iStart, int iEnd, ref bool pbForceStop)
		{
			return _uDsoSDKMeasExStart(iStart, iEnd, ref pbForceStop);
		}

		[DllImport("DSOSDK.dll", CallingConvention = CallingConvention.StdCall, EntryPoint = "uDsoSDKMeasExGetResult")]
		private static extern bool _uDsoSDKMeasExGetResult(int iType);
		public bool uDsoSDKMeasExGetResult(int iType)
		{
			return _uDsoSDKMeasExGetResult(iType);
		}

		[DllImport("DSOSDK.dll", CallingConvention = CallingConvention.StdCall, EntryPoint = "uDsoSDKMeasExGetValue")]
		private static extern double _uDsoSDKMeasExGetValue(int iType);
		public double uDsoSDKMeasExGetValue(int iType)
		{
			return _uDsoSDKMeasExGetValue(iType);
		}

		[DllImport("DSOSDK.dll", CallingConvention = CallingConvention.StdCall, EntryPoint = "uDsoSDKMeasExFreeResource")]
		private static extern bool _uDsoSDKMeasExFreeResource();
		public bool uDsoSDKMeasExFreeResource()
		{
			return _uDsoSDKMeasExFreeResource();
		}


		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetWorkDir")]
		private static extern bool _uDsoSDKSetWorkDir([MarshalAs(UnmanagedType.LPStr)]string lpsDirectory);
		public bool uDsoSDKSetWorkDir([MarshalAs(UnmanagedType.LPStr)]string lpsDirectory)
		{
			return _uDsoSDKSetWorkDir(lpsDirectory);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKInit")]
		private static extern Int32 _uDsoSDKInit();
		public Int32 uDsoSDKInit()
		{
			return _uDsoSDKInit();
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKInitStack")]
		private static extern Int32 _uDsoSDKInitStack([MarshalAs(UnmanagedType.LPStr)]string szSNString);
		public Int32 uDsoSDKInitStack([MarshalAs(UnmanagedType.LPStr)]string szSNString)
		{
			return _uDsoSDKInitStack(szSNString);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSelectGroup")]
		private static extern bool _uDsoSDKSelectGroup(int iGroup);
		public bool uDsoSDKSelectGroup(int iGroup)
		{
			return _uDsoSDKSelectGroup(iGroup);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKGetVendorName")]
		private static extern bool _uDsoSDKGetVendorName(int iDevice, [MarshalAs(UnmanagedType.LPStr)]StringBuilder szVendorName);
		public bool uDsoSDKGetVendorName(int iDevice, [MarshalAs(UnmanagedType.LPStr)]StringBuilder szVendorName)
		{
			return _uDsoSDKGetVendorName(iDevice, szVendorName);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKGetProductName")]
		private static extern bool _uDsoSDKGetProductName(int iDevice, [MarshalAs(UnmanagedType.LPStr)]StringBuilder szProductName);
		public bool uDsoSDKGetProductName(int iDevice, [MarshalAs(UnmanagedType.LPStr)] StringBuilder szProductName)
		{
			return _uDsoSDKGetProductName(iDevice, szProductName);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKGetSerialNum")]
		private static extern bool _uDsoSDKGetSerialNum(int iDevice, [MarshalAs(UnmanagedType.LPStr)]StringBuilder szSerialNum);
		public bool uDsoSDKGetSerialNum(int iDevice, [MarshalAs(UnmanagedType.LPStr)]StringBuilder szSerialNum)
		{
			return _uDsoSDKGetSerialNum(iDevice, szSerialNum);
		}


		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKGetCalibrationData")]
		private static extern bool _uDsoSDKGetCalibrationData(int iDevice, double[] pdbValue);
		public bool uDsoSDKGetCalibrationData(int iDevice, double[] pdbValue)
		{
			return _uDsoSDKGetCalibrationData(iDevice, pdbValue);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKAutoset")]
		private static extern bool _uDsoSDKAutoset();
		public bool uDsoSDKAutoset()
		{
			return _uDsoSDKAutoset();
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKReadIniFile")]
		private static extern bool _uDsoSDKReadIniFile([MarshalAs(UnmanagedType.LPStr)]string strFileName);
		public bool uDsoSDKReadIniFile([MarshalAs(UnmanagedType.LPStr)]string strFileName)
		{
			return _uDsoSDKReadIniFile(strFileName);
		}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetBWL")]
		//private static extern bool _uDsoSDKSetBWL(int iCh, int iBwlFlag);
		//public bool uDsoSDKSetBWL(int iCh, int iBwlFlag) 
		//{
		//    return _uDsoSDKSetBWL(iCh, iBwlFlag);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetCoupling")]
		//private static extern bool _uDsoSDKSetCoupling(int iCh, int iCouplingFlag);
		//public bool uDsoSDKSetCoupling(int iCh, int iCouplingFlag) 
		//{
		//    return _uDsoSDKSetCoupling(iCh, iCouplingFlag);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetChOnOff")]
		//private static extern bool _uDsoSDKSetChOnOff(int iCh, bool bChOn);
		//public bool uDsoSDKSetChOnOff(int iCh, bool bChOn) 
		//{
		//    return _uDsoSDKSetChOnOff(iCh, bChOn);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetAcquireMode")]
		//private static extern bool _uDsoSDKSetAcquireMode(int iCh, int iAcquireMode);
		//public bool uDsoSDKSetAcquireMode(int iCh, int iAcquireMode) 
		//{
		//    return _uDsoSDKSetAcquireMode(iCh, iAcquireMode);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetTrigCouple")]
		//private static extern bool _uDsoSDKSetTrigCouple(int iTrigCoupleFlag);
		//public bool uDsoSDKSetTrigCouple(int iTrigCoupleFlag) 
		//{
		//    return _uDsoSDKSetTrigCouple(iTrigCoupleFlag);
		//}
		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetVoltDiv")]
		//private static extern bool _uDsoSDKSetVoltDiv(int iCh, int iVoltDiv_uV);
		//public bool uDsoSDKSetVoltDiv(int iCh, int iVoltDiv_uV) 
		//{
		//    return _uDsoSDKSetVoltDiv(iCh, iVoltDiv_uV);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetVoltDivEx")]
		//private static extern bool _uDsoSDKSetVoltDivEx(int iCh, int iVoltDiv_uV);
		//public bool uDsoSDKSetVoltDivEx(int iCh, int iVoltDiv_uV) 
		//{
		//    return _uDsoSDKSetVoltDivEx(iCh, iVoltDiv_uV);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetVoltPos")]
		//private static extern bool _uDsoSDKSetVoltPos(int iCh, int iPosition);
		//public bool uDsoSDKSetVoltPos(int iCh, int iPosition) 
		//{
		//return _uDsoSDKSetVoltPos(iCh, iPosition);
		//}	//0~16000

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetVoltOfs")]
		//private static extern bool _uDsoSDKSetVoltOfs(int iCh, int iVoltOfs_uV);
		//public bool uDsoSDKSetVoltOfs(int iCh, int iVoltOfs_uV) 
		//{
		//    return _uDsoSDKSetVoltOfs(iCh, iVoltOfs_uV);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetHwBit")]
		//private static extern bool _uDsoSDKSetHwBit(int iHwBit);
		//public bool uDsoSDKSetHwBit(int iHwBit) 
		//{
		//    return _uDsoSDKSetHwBit(iHwBit);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetSampleRate")]
		//private static extern bool _uDsoSDKSetSampleRate(Int64 i64SampleRate);
		//public bool uDsoSDKSetSampleRate(Int64 i64SampleRate) 
		//{
		//    return _uDsoSDKSetSampleRate(i64SampleRate);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetRecordLength")]
		//private static extern bool _uDsoSDKSetRecordLength(int iRecordLength);
		//public bool uDsoSDKSetRecordLength(int iRecordLength) 
		//{
		//    return _uDsoSDKSetRecordLength(iRecordLength);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetWaitMode")]
		//private static extern bool _uDsoSDKSetWaitMode(int iWaitMode, Int64 i64CustomWaitTime_ps);
		//public bool uDsoSDKSetWaitMode(int iWaitMode, Int64 i64CustomWaitTime_ps) 
		//{
		//    return _uDsoSDKSetWaitMode(iWaitMode, i64CustomWaitTime_ps);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetDelayTime")]
		//private static extern bool _uDsoSDKSetDelayTime(Int64 i64DelayTime_ps);
		//public bool uDsoSDKSetDelayTime(Int64 i64DelayTime_ps) 
		//{
		//    return _uDsoSDKSetDelayTime(i64DelayTime_ps);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetHoldoffTime")]
		//private static extern bool _uDsoSDKSetHoldoffTime(Int64 i64HoldOffTime_ps);
		//public bool uDsoSDKSetHoldoffTime(Int64 i64HoldOffTime_ps) 
		//{
		//return _uDsoSDKSetHoldoffTime(i64HoldOffTime_ps);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetTrigPos")]
		//private static extern bool _uDsoSDKSetTrigPos(Int64 i64TrigPosition);
		//public bool uDsoSDKSetTrigPos(Int64 i64TrigPosition) 
		//{
		//    return _uDsoSDKSetTrigPos(i64TrigPosition);
		//}
		////Trigger Setting
		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetEdgeTrig")]
		//private static extern bool _uDsoSDKSetEdgeTrig(int iCh, int iSlope, Int64 i64Threshold_uV);
		//public bool uDsoSDKSetEdgeTrig(int iCh, int iSlope, Int64 i64Threshold_uV) 
		//{
		//    return _uDsoSDKSetEdgeTrig(iCh, iSlope, i64Threshold_uV);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetVideoTrig")]
		//private static extern bool _uDsoSDKSetVideoTrig(int iCh, int iMode, int iScanline);
		//public bool uDsoSDKSetVideoTrig(int iCh, int iMode, int iScanline) 
		//{
		//return _uDsoSDKSetVideoTrig(iCh, iMode, iScanline);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetRuntTrig")]
		//private static extern bool _uDsoSDKSetRuntTrig(int iCh, int iPolarity, int iCompareType, int iEqualRange, Int64 i64Width_ps, Int64 i64Threshold1_uV, Int64 i64Threshold2_uV);
		//public bool uDsoSDKSetRuntTrig(int iCh, int iPolarity, int iCompareType, int iEqualRange, Int64 i64Width_ps, Int64 i64Threshold1_uV, Int64 i64Threshold2_uV) 
		//{
		//return _uDsoSDKSetRuntTrig(iCh, iPolarity, iCompareType, iEqualRange, i64Width_ps, i64Threshold1_uV, i64Threshold2_uV);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetWidthTrig")]
		//private static extern bool _uDsoSDKSetWidthTrig(int iCh, int iPolarity, int iCompareType, int iEqualRange, Int64 i64Width_ps, Int64 i64Threshold_uV);
		//public bool uDsoSDKSetWidthTrig(int iCh, int iPolarity, int iCompareType, int iEqualRange, Int64 i64Width_ps, Int64 i64Threshold_uV) 
		//{
		//    return _uDsoSDKSetWidthTrig(iCh, iPolarity, iCompareType, iEqualRange, i64Width_ps, i64Threshold_uV);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetPatternTrig")]
		//private static extern bool _uDsoSDKSetPatternTrig(int iSrcA, int iSrcB, int iNotA, int iNotB, int iAndOr, Int64 i64Width_ps, Int64 i64ThresholdA_uV, Int64 i64ThresholdB_uV);
		//public bool uDsoSDKSetPatternTrig(int iSrcA, int iSrcB, int iNotA, int iNotB, int iAndOr, Int64 i64Width_ps, Int64 i64ThresholdA_uV, Int64 i64ThresholdB_uV) 
		//{
		//    return _uDsoSDKSetPatternTrig(iSrcA, iSrcB, iNotA, iNotB, iAndOr, i64Width_ps, i64ThresholdA_uV, i64ThresholdB_uV);
		//}

		//[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetStateTrig")]
		//private static extern bool _uDsoSDKSetStateTrig(int iSrcA, int iSrcB, int iNotA, int iNotB, int iAndOr, Int64 i64ThresholdA_uV, Int64 i64ThresholdB_uV);
		//public bool uDsoSDKSetStateTrig(int iSrcA, int iSrcB, int iNotA, int iNotB, int iAndOr, Int64 i64ThresholdA_uV, Int64 i64ThresholdB_uV) 
		//{
		//    return _uDsoSDKSetStateTrig(iSrcA, iSrcB, iNotA, iNotB, iAndOr, i64ThresholdA_uV, i64ThresholdB_uV);
		//}



		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKSetting")]
		private static extern bool _uDsoSDKSetting(int iCh, int iItem, int iValue);
		public bool uDsoSDKSetting(int iCh, int iItem, int iValue) 
		{
			return _uDsoSDKSetting(iCh, iItem, iValue);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKCaptureEx")]
		private static extern bool _uDsoSDKCaptureEx();
		public bool uDsoSDKCaptureEx() 
		{
			return _uDsoSDKCaptureEx();
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKReadExRaw")]
		private static extern bool _uDsoSDKReadExRaw(int iDev, ref int piFlag, [In, Out]short[] lpsData, [In, Out]double[] pdbYofsA, [In, Out]double[] pdbYofsB, [In, Out]double[] pdbYMul, ref int piTrigOfs);
		public bool uDsoSDKReadExRaw(int iDev, ref int piFlag, [In, Out]short[] lpsData, [In, Out]double[] pdbYofsA, [In, Out]double[] pdbYofsB, [In, Out]double[] pdbYMul, ref int piTrigOfs)
		{
			return _uDsoSDKReadExRaw(iDev, ref piFlag, lpsData, pdbYofsA, pdbYofsB, pdbYMul, ref piTrigOfs);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKReadDbl_mv")]
		private static extern bool _uDsoSDKReadDbl_mv(int iDev, ref int piFlag, [In, Out]double[] lpsData, [In, Out]int[] piProbe);
		public bool uDsoSDKReadDbl_mv(int iDev, ref int piFlag, [In, Out]double[] lpsData, [In, Out]int[] piProbe)
		{
			return _uDsoSDKReadDbl_mv(iDev, ref piFlag, lpsData, piProbe);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKReadDbl_uv")]
		private static extern bool _uDsoSDKReadDbl_uv(int iDev, ref int piFlag, [In, Out]double[] lpsData, [In, Out]int[] piProbe);
		public bool uDsoSDKReadDbl_uv(int iDev, ref int piFlag, [In, Out]double[] lpsData, [In, Out]int[] piProbe)
		{
			return _uDsoSDKReadDbl_uv(iDev, ref piFlag, lpsData, piProbe);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKStop")]
		private static extern bool _uDsoSDKStop();
		public bool uDsoSDKStop() 
		{
			return _uDsoSDKStop();
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKGetStatus")]
		private static extern Int32 _uDsoSDKGetStatus(int iDevice);
		public Int32 uDsoSDKGetStatus(int iDevice) 
		{
			return _uDsoSDKGetStatus(iDevice);
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKDataReady")]
		private static extern bool _uDsoSDKDataReady();
		public bool uDsoSDKDataReady() 
		{
			return _uDsoSDKDataReady();
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKGetErrorCode")]
		private static extern Int32 _uDsoSDKGetErrorCode();
		public Int32 uDsoSDKGetErrorCode() 
		{
			return _uDsoSDKGetErrorCode();
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKGetErrorCodeEx")]
		private static extern Int32 _uDsoSDKGetErrorCodeEx();
		public Int32 uDsoSDKGetErrorCodeEx() 
		{
			return _uDsoSDKGetErrorCodeEx();
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKForceTrig")]
		private static extern bool _uDsoSDKForceTrig();
		public bool uDsoSDKForceTrig() 
		{
			return _uDsoSDKForceTrig();
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKShutdown")]
		private static extern bool _uDsoSDKShutdown();
		public bool uDsoSDKShutdown() 
		{
			return _uDsoSDKShutdown();
		}

		[DllImport("DSOSDK.dll", CallingConvention=CallingConvention.StdCall, EntryPoint = "uDsoSDKGetDeviceCount")]
		private static extern Int32 _uDsoSDKGetDeviceCount();
		public Int32 uDsoSDKGetDeviceCount() 
		{
			return _uDsoSDKGetDeviceCount();
		}

		
	}
}
